#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, q;
    cin>>n >> q;
    for (int i=1; i<=n; i++) {
        int a;
        cin >> a;
    }

    for (int i=1; i<=q; i++) {
        int type, l, r;
        cin >> type >> l >> r;
        int res = r - l + 1;
        if (l % 2 == 0) res--;
        if (r % 2 == 0) res--;

        cout << res << endl;
    }
}
